C**********************************************************************
C                 Copyright 1992-1996, Robert Fraczkiewicz            *
C                           All rights reserved.                      *
C**********************************************************************
C This program is free software; you can redistribute it and/or modify*
C it under the terms of the GNU General Public License as published by*
C the Free Software Foundation; either version 1, or (at your option) *
C any later version.                                                  *
C                                                                     *
C This program is distributed in the hope that it will be useful,     *
C but WITHOUT ANY WARRANTY; without even the implied warranty of      *
C MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU    *
C General Public License for more details.                            *
C                                                                     *
C You should  have received a copy of the GNU General Public License  *
C along with this program; if not, write to the Free Software         *
C Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.           *
***********************************************************************
* Program ZSIN - accelerator of the force field input creation.       *
* Takes `name`.dat file containing force constants definitions        *
* NROW NCOL NCONSTANT      (NCOL must be >= NROW)                     *
* and converts them to standard `name`.zsin input with all factors    *
* equal to 1.0. User must edit header of `name`.zsin.                 *
* Force constants are renumbered during conversion.                   *
***********************************************************************
      implicit real*8(a-h,o-z)
      character*14 name,cr
      parameter (one=1.0)
      dimension nr(10000),nc(10000),nfo(10000)

      print *
      print *,'           creation of zsym input file                 '
      print *,'            zsin  version 1.0 (1993)                   '
      print *
      print *,'input the name of the file (without extension !!!)     '
      print *,'where the data is stored and press <return>. the ".dat"'
      print *,'extension will be automatically assumed.               '
      print *,'the length of the name cannot exceed 14 characters.    '
      read(*,'(a14)') name
      l_name=namlen(name)
      print *,'Enter the number of internal coordinates:              '
      read(*,*) ncoor
      print *,'Enter the number of force constants:                   '
      read(*,*) nf
      open(unit=7, file=name(1:l_name)//'.dat', err=9990, status='old') 
      open(unit=8, file=name(1:l_name)//'.zsin', status='unknown')
      print *,'the results of the program will be stored in the    '
      print *,'output file with extension ".zsin".'
      print *,'press <return> when ready...'
      read(*,'(a14)') cr
      noz=0
   10 noz=noz+1
      read(7,*,err=999) nr(noz),nc(noz),nfo(noz)
      goto 10
  999 nr(noz)=-2
      nc(noz)=0
      nfo(noz)=0
      i=2
   15 nfold=nfo(i-1)
      if(nfo(i).gt.nfold+1) then
   20  if(nfo(i+1).eq.nfo(i)) then
        nfo(i)=nfold+1
        i=i+1
        goto 20
       endif
       nfo(i)=nfold+1
      endif
      i=i+1
      if(i.gt.noz) goto 25
      goto 15
   25 i=2
   26 nfold=nfo(i-1)
      if(nfo(i).lt.nfold) then
   27  if(nfo(i+1).eq.nfo(i)) then
        nfo(i)=nfold+1
        i=i+1
        goto 27
       endif
       nfo(i)=nfold+1
      endif
      i=i+1
      if(i.gt.noz) goto 30
      goto 26
   30 write(8,*) name(1:l_name)
      write(8,40) ncoor,nf
      write(8,50)
      write(8,50)
      li=1
      lcurr=1
      do l=2,noz
       if(nfo(l).eq.nfo(lcurr)) then
        li=li+1
       else
        last=lcurr+li-1
        if(li.gt.5) then
         write(8,60)nfo(lcurr),li,(nr(m),nc(m),one,
     .                               m=lcurr,lcurr+4)
         lb=int(li/5)
         do il=2,lb
          l0=lcurr+5*(il-1)
          ll=lcurr+5*il-1
          write(8,70)(nr(m),nc(m),one,m=l0,ll)
         enddo
         write(8,70)(nr(m),nc(m),one,m=lcurr+5*lb,last)
        else
         write(8,60)nfo(lcurr),li,(nr(m),nc(m),one,m=lcurr,last)
        endif     
        li=1
        lcurr=l   
       endif
      enddo
   40 format(1x,i4,1x,i4)
   50 format(1x,'Edit header here ...')
   60 format(1x,i3,1x,i3,5(1x,i3,1x,i3,1x,f4.1))
   70 format(8x,5(1x,i3,1x,i3,1x,f4.1))
      close(unit=7)
      close(unit=8)
      stop 0
c  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 9990 print *
      print *,'input operation unsuccesful. check the name and format'
      print *,'of the data file. don"t input extension of filename !'
      stop 2
c  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      end

      integer function namlen(stri)
      implicit real*8(a-h,o-z)
      character*14 stri
      do i=1,len(stri)
       if(stri(i:i).eq.' ') goto 2
      enddo
    2 namlen=i-1
      return
      end
